﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Protocols;
using ServerLib;
using System.Net;
using Event;
using Log;
using AdventureGrainInterfaces.PlayerGrain;

namespace Module
{
    public class GateSessionInfo
    {
        public GateSessionInfo(UInt64 accountId, string sessionId)
        {
            this.accountId = accountId;
            this.sessionId = sessionId;
        }

        public UInt64 accountId = 0;

        public string sessionId = "";
    }

    /// <summary>
    /// 增强的报文处理接口样式
    /// </summary>
    /// <param name="protoBody"></param>
    /// <param name="from"></param>
    /// <param name="sessionId"></param>
    public delegate Task MsgHandlerEx<T>(T protoBody, string sessionId);

    /// <summary>
    /// 玩家消息
    /// </summary>
    /// <typeparam name="T"></typeparam>
    /// <param name="self"></param>
    /// <param name="protoBody"></param>
    public delegate Task MsgHandler<T>(PlayerGrain self, T protoBody);


    public delegate Task MsgHandlerAll<T>(GateSessionInfo serverBody, T protoBody);


    public abstract class LogicModule : ILogicModule
    {
        public LogicModule()
        {
        }

        public virtual UInt32 Id
        {
            get
            {
                return 0xff;
            }
        }

        public bool Init()
        {
            return OnInit();
        }

        public bool PostInit()
        {
            return OnPostInit();
        }

        public void PreDestroy()
        {
            OnPreDestroy();
        }

        public void Destroy()
        {
            OnDestroy();
        }

        public void Tick()
        {
            OnTick();
        }

        protected virtual bool OnInit()
        {
            return true;
        }

        protected virtual bool OnPostInit()
        {
            return true;
        }

        protected virtual void OnPreDestroy()
        {
        }

        protected virtual void OnDestroy()
        {
        }

        protected virtual void OnTick()
        {
        }
    }
}
